upper_case_letter 	  [A-Z]
digit 			  [0-9]
special_character   	  [\#\&\'\(\)\*\+\,\-\.\/\:\;\<\=\>\_\|]
space_character 	  [ \t]
formaeffector		  [\t\v\r\l\f]
end_of_line		  \n
lower_case_letter 	  [a-z]
other_special_character   [\!\$\@\?\[\\\]\^\`\{\}\~]
graphic_character	  ({basic_graphic_character}|{lower_case_letter}|{other_special_character})
basic_graphic_character	  ({upper_case_letter}|{digit}|{special_character}|{space_character})
decimal_literal	   	  {integer}(\.{integer})?({exponent})?
integer		   	  {digit}(_?{digit})*
exponent	   	  ([eE][-+]?{integer})
base		   	  {integer}
based_integer	   	  {extended_digit}(_?{extended_digit})*
extended_digit	   	  ({digit}|[a-fA-F])
base_specifier	  	  (B|b|O|o|X|x)

letter		   	  ({upper_case_letter}|{lower_case_letter})
letter_or_digit	   	  ({letter}|{digit})
word			  {letter}(_?{letter_or_digit})*

abstraclit		  ({decimal_literal})|({base}#{based_integer}(\.{based_integer})?#({exponent})?)|({base}:{based_integer}(\.{based_integer})?:({exponent})?)
character_lit		  '({graphic_character}|\"|\%)'
string_lit		  (\"({graphic_character}|(\"\")|\%)*\")|(\%({graphic_character}|(\%\%)|\")*\%)
bistring_lit		  {base_specifier}(\"{extended_digit}(_?{extended_digit})*\"|\%{extended_digit}(_?{extended_digit})*\%)


%%
"abs"			{ count(); newline=0; return(q(ABS)); }
"access"		{ count(); newline=0; return(q(ACCESS)); }
"after"			{ count(); newline=0; return(q(AFTER)); }
"alias"			{ count(); newline=0; return(q(ALIAS)); }
"all"			{ count(); newline=0; return(q(ALL)); }
"and"			{ count(); newline=0; return(q(AND)); }
"architecture"		{ count(); newline=0; return(q(ARCHITECTURE)); }
"array"			{ count(); newline=0; return(q(ARRAY)); }
"assert"		{ count(); newline=0; return(q(ASSERT)); }
"attribute"		{ count(); newline=0; return(q(ATTRIBUTE)); }

"begin"			{ count(); newline=0; return(q(t_BEGIN)); }
"block"			{ count(); newline=0; return(q(BLOCK)); }
"body"			{ count(); newline=0; return(q(BODY)); }
"buffer"		{ count(); newline=0; return(q(BUFFER)); }
"bus"			{ count(); newline=0; return(q(BUS)); }

"case"			{ count(); Inc_Scope(); newline=0; return(q(CASE)); }
"component"		{ count(); Inc_Scope(); newline=0; return(q(COMPONENT)); }
"configuration"		{ count(); newline=0; return(q(CONFIGURATION)); }
"constant"		{ count(); newline=0; return(q(CONSTANT)); }

"disconnect"		{ count(); newline=0; return(q(DISCONNECT)); }
"downto"		{ count(); newline=0; return(q(DOWNTO)); }

"else"			{ count(); newline=0; return(q(ELSE)); }
"elsif"			{ count(); newline=0; return(q(ELSIF)); }
"end"			{ count(); newline=0; return(q(END)); }
"entity"		{ count(); newline=0; return(q(ENTITY)); }
"exit"			{ count(); newline=0; return(q(EXIT)); }

"file"			{ count(); newline=0; return(q(t_FILE)); }
"for"			{ count(); newline=0; return(q(FOR)); }
"function"		{ count(); newline=0; return(q(FUNCTION)); }

"generate"		{ count(); newline=0; return(q(GENERATE)); }
"generic"		{ count(); newline=0; return(q(GENERIC)); }
"guarded"		{ count(); newline=0; return(q(GUARDED)); }

"if"			{ count(); Inc_Scope(); newline=0; return(q(IF)); }
"in"			{ count(); newline=0; return(q(IN)); }
"inout"			{ count(); newline=0; return(q(INOUT)); }
"is"			{ count(); newline=0; return(q(IS)); }

"label"			{ count(); newline=0; return(q(LABEL)); }
"library"		{ count(); newline=0; return(q(LIBRARY)); }
"linkage"		{ count(); newline=0; return(q(LINKAGE)); }
"loop"			{ count(); newline=0; return(q(LOOP)); }

"map"			{ count(); newline=0; return(q(MAP)); }
"mod"			{ count(); newline=0; return(q(MOD)); }

"nand"			{ count(); newline=0; return(q(NAND)); }
"new"			{ count(); newline=0; return(q(NEW)); }
"next"			{ count(); newline=0; return(q(NEXT)); }
"nor"			{ count(); newline=0; return(q(NOR)); }
"not"			{ count(); newline=0; return(q(NOT)); }
"null"			{ count(); newline=0; return(q(t_NULL)); }

"of"			{ count(); newline=0; return(q(OF)); }
"on"			{ count(); newline=0; return(q(ON)); }
"open"			{ count(); newline=0; return(q(OPEN)); }
"or"			{ count(); newline=0; return(q(OR)); }
"others"		{ count(); newline=0; return(q(OTHERS)); }
"out"			{ count(); newline=0; return(q(OUT)); }

"package"		{ count(); newline=0; return(q(PACKAGE)); }
"port"			{ count(); newline=0; return(q(PORT)); }
"procedure"		{ count(); newline=0; return(q(PROCEDURE)); }
"process"		{ count(); newline=0; return(q(PROCESS)); }

"range"			{ count(); newline=0; return(q(RANGE)); }
"record"		{ count(); Inc_Scope(); newline=0; return(q(RECORD)); }
"register"		{ count(); newline=0; return(q(REGISTER)); }
"rem"			{ count(); newline=0; return(q(REM)); }
"report"		{ count(); newline=0; return(q(REPORT)); }
"return"		{ count(); return(q(RETURN)); }

"select"		{ count(); newline=0; return(q(SELECT)); }
"severity"		{ count(); newline=0; return(q(SEVERITY)); }
"signal"		{ count(); newline=0; return(q(SIGNAL)); }
"subtype"		{ count(); newline=0; return(q(SUBTYPE)); }

"then"			{ count(); newline=0; return(q(THEN)); }
"to"			{ count(); newline=0; return(q(TO)); }
"transport"		{ count(); newline=0; return(q(TRANSPORT)); }
"type"			{ count(); newline=0; return(q(TYPE)); }

"units"			{ count(); newline=0; return(q(UNITS)); }
"until"			{ count(); newline=0; return(q(UNTIL)); }
"use"			{ count(); newline=0; return(q(USE)); }

"variable"		{ count(); newline=0; return(q(VARIABLE)); }

"wait"			{ count(); newline=0; return(q(WAIT)); }
"when"			{ count(); newline=0; return(q(WHEN)); }
"while"			{ count(); newline=0; return(q(WHILE)); }
"with"			{ count(); newline=0; return(q(WITH)); }

"xor"			{ count(); newline=0; return(q(XOR)); }

{space_character}	{ count(); }
\&			{ count(); newline=0; return(p(Ampersand)); }
\'			{ count(); newline=0; return(p(Apostrophe)); }
\(			{ count(); newline=0; return('('); }
\)			{ count(); newline=0; return(')'); }
"**"			{ count(); newline=0; return(p(DoubleStar)); }
\*			{ count(); newline=0; return(p(Star)); }
\+			{ count(); newline=0; return(p(Plus)); }
\,			{ count(); newline=0; return(','); }
\-			{ count(); newline=0; return(p(Minus)); }
":="			{ count(); newline=0; return(p(VarAsgn)); }
\:			{ count(); newline=0; return(':'); }
\;			{ count(); newline=0; return(';'); }
"<="			{ count(); newline=0; return(p(LESym)); }
">="			{ count(); newline=0; return(p(GESym)); }
\<			{ count(); newline=0; return(p(LTSym)); }
\>			{ count(); newline=0; return(p(GTSym)); }
=			{ count(); newline=0; return(p(EQSym)); }
\/=			{ count(); newline=0; return(p(NESym)); }
"=>"			{ count(); Inc_Scope(); newline=0; return(p(Arrow)); }
"<>"			{ count(); newline=0; return(p(Box)); }
\|			{ count(); newline=0; return(p(Bar)); }
!			{ count(); newline=0; return(p(Bar)); }
\.			{ count(); newline=0; return('.'); }
\/			{ count(); newline=0; return(p(Slash)); }
\n			{ line_number++; count(); newline++; }
{word}			{ count(); newline=0; return ( p(Identifier)); }
{abstraclit}		{ count(); newline=0; return ( p(AbstractLit)); }
{character_lit}		{ count(); newline=0; return ( p(CharacterLit)); }
{string_lit}		{ count(); newline=0; return ( p(StringLit)); }
{bistring_lit}		{ count(); newline=0; return ( p(BitStringLit)); }

\-\-.*$ 		{
				temp_lex = Combine(Return_Newlines(newline),comment_string);
				comment_string = Combine(temp_lex,yytext);
				temp_lex = Combine(comment_string,"\n");
				comment_string = temp_lex;
				comment();
				count();
				newline=0;
			}
.			{ count(); }

%%
/****************************************************************
 *
 *  Copyright (c) 1995, Case Western Reserve University
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms are permitted
 *  provided that the above copyright notice and this paragraph are
 *  duplicated in all such forms and that any documentation,
 *  advertising materials, and other materials related to such
 *  distribution and use acknowledge that the software was developed
 *  by the Case Western Reserve University.  The name of the Case
 *  Western Reserve University may not be used to endorse or promote
 *  products derived from this software without specific prior written
 *  permission.
 *
 *  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 *  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 *  WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *  This program is intended not to be used for commercial purposes
 *  without permission of the Case Western Reserve University 
 *  and without the permission of those who developed the YACC grammer.
 * 
 *  AUTHOR:
 *      Michael Knieser
 *      Case Western Reserve University
 *      Department of Computer and Electrical Engineering
 *      10900 Euclid Av.
 *      Cleveland, OH 44118
 *      USA
 *      Phone: (216) 932-7135
 *      e-mail: knieser@alpha.ces.cwru.edu
 *  Version : 0.1
 *  Date : 8/15/95
 *
 ****************************************************************/


yywrap()
{
        return(1);
}

int column = 0;

void comment()
{
	char c;

	while ((c = input()) != '\n');

	line_number++;
}

void count()
{
        int i;

        for (i = 0; yytext[i] != '\0'; i++)
                if (yytext[i] == '\n')
                        column = 0;
                else if (yytext[i] == '\t')
                        column += 8 - (column % 8);
                else
                        column++;

/*
	ECHO;
*/
}

